/*******************************************************************************
 *
 * blueMarine - open source photo workflow
 * =======================================
 *
 * Copyright (C) 2003-2009 by Fabrizio Giudici
 * Project home page: http://bluemarine.tidalwave.it
 *
 *******************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0 
 * 
 * Unless required by applicable law or agreed to in writing, software 
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 *
 *******************************************************************************
 *
 * $Id: MetadataPanelProvider.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
package it.tidalwave.metadata.viewer;

import javax.annotation.CheckForNull;
import javax.annotation.Nonnull;
import javax.swing.JComponent;
import org.openide.loaders.DataObject;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: MetadataPanelProvider.java,v d60681e7fc1d 2009/09/17 23:59:23 fabrizio $
 *
 ******************************************************************************/
public interface MetadataPanelProvider 
  {
    /***************************************************************************
     *
     *
     **************************************************************************/
    @Nonnull
    public String getDisplayName();
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    public boolean isDataObjectSupported (@Nonnull DataObject dataObject);
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    @Nonnull
    public JComponent createPanel();

    /***************************************************************************
     *
     *
     **************************************************************************/
    public void setDataObject (@CheckForNull DataObject dataObject);
    
    /***************************************************************************
     *
     *
     **************************************************************************/
    @CheckForNull
    public DataObject getDataObject();
  }
